//SETA43 22/04/2015
// 
// A/D  ->  D/A
// Grabador reproductor de audio
// 

#include <SD.h>
File dataFile;

String inputString = "";  
char fileplay[20] ;
boolean stringComplete = false;  

byte valor;
byte bufer0[100];
byte bufer1[100];
int din=0;
int dout=0;
byte nf=0;
byte vacio=1;
byte fin=1;

int z;
byte modo; 
byte z1;
//0=pasa entrada a salida directamente
//1=reproduce
//2=graba

void setup()
{
  
  modo=0;
  
  Serial.begin(9600);  
  inputString.reserve(50);
  
  pinMode(9, OUTPUT);
 
 // pinMode(4, OUTPUT);    // si utilizamos la salida 4 como CS de la tarjeta SD
 // if(!SD.begin(4)){    //  
   pinMode(10, OUTPUT);    // si utilizamos la salida 4 como CS de la tarjeta SD
  if(!SD.begin(10)) 
  {
    Serial.println("Tarjeta erronea o no insertada");    // Texto informativo
    return;
  }
  else
  {
    Serial.println("Tarjeta OK");    // Texto informativo
  }
  
  //_______________________a/d  fast__________
  bitWrite(ADCSRA,ADPS2,1);
  bitWrite(ADCSRA,ADPS1,0);
  bitWrite(ADCSRA,ADPS0,0); 
  //Analog Input A0
  ADMUX=(1<<ADLAR)|(0<<REFS1)|(1<<REFS0)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0);
  //__________________________________________
  
ClearBuffer(); 
  
cli();//stop interrupts

TCCR1A = 0x81;
TCCR1B = 0x01;
OCR1A = 255;
TIMSK1=0;

//timer interrupts
//by Amanda Ghassaei
//set timer2 interrupt at 11kHz
  TCCR2A = 0;// set entire TCCR2A register to 0
  TCCR2B = 0;// same for TCCR2B
  TCNT2  = 0;//initialize counter value to 0
  OCR2A = 182;// = (16*10^6) / (11000*8) - 1 (must be <256)  11khz
  // turn on CTC mode
  TCCR2A |= (1 << WGM21);
  // Set CS21 bit for 8 prescaler
  TCCR2B |= (1 << CS21);      
  // enable timer compare interrupt
  TIMSK2 |= (1 << OCIE2A);
sei();//allow interrupts
}//end setup


ISR(TIMER2_COMPA_vect)
{ 
   //timer1 interrupt 11kHz toggles 
  switch (modo)
       {
        case 0:  //pase
          valor=analogReadFast();  
          OCR1AH = 0; 
          OCR1AL = valor;     
          //PORTC= valor; 
         break; 
        case 1: //reproduce
          if(nf==0)
            valor=bufer1[dout];
           else
            valor=bufer0[dout];
          dout++;
          if(dout>99)
              {
               vacio=1;
               dout=0;
               if(nf==1)
                 nf=0;
                else
                 nf=1;       
              }  
          OCR1AH = 0; 
          OCR1AL = valor;               
         break;         
        case 2://graba
         valor=analogReadFast();
         OCR1AH = 0; 
         OCR1AL = valor;  
         
         if(nf==0)
            bufer1[dout]=valor;
           else
            bufer0[dout]=valor;
          dout++;
          if(dout>99)
              {
               vacio=1;
               dout=0;
               if(nf==1)
                 nf=0;
                else
                 nf=1;       
              }                     
         break;         
       }  
}

void loop()
{
  
  switch (modo)
       {
         case 0:  //paso
        
         break; 
//_________________________________________________________         
         case 1: //reproduce
              if(vacio == 1 && fin == 0)
                {     
                 if(nf==0) for(din=0;din<100;din++) bufer0[din] = dataFile.read();
                 if(nf==1) for(din=0;din<100;din++) bufer1[din] = dataFile.read();
                 vacio=0;
                 if(!dataFile.available())
                     {
                       Serial.println("Fin de cancion");
                       ClearBuffer();
                       fin=1;
                     }
               } 
    
              if (stringComplete) 
                  {
                   if(strcmp(fileplay, "stop")  == 0)
                     {
                       Serial.println("Stop cancion");
                       ClearBuffer();
                       dataFile.close();
                       fin=1;         
                     }
                    else
                     {        
                      dataFile.close();
                      dataFile = SD.open(fileplay,FILE_READ);
                      if (dataFile) 
                        {
                         Serial.print("OK ");
                         for(din=0;din<1000;din++) dataFile.read(); //quita 1000 bytes del wav
                         fin=0;
                        }
                        else
                        {
                         Serial.print("Error "); 
                        }
                        Serial.println(fileplay);
                     }      
                  inputString = "";
                  stringComplete = false;
                 }            
         break; 
 //_________________________________________________________        
         case 2://graba
         
         if(vacio == 1 && fin == 0)
                {     
                 if(nf==0) dataFile.write(bufer0,100);
                 if(nf==1) dataFile.write(bufer1,100);
                 vacio=0;                 
               }          
         
         if (stringComplete) 
            {    
             if(strcmp(fileplay, "stop")  == 0)
             {               
               Serial.println("Stop cancion");               
               dataFile.close();
               ClearBuffer();               
               fin=1;
             }
           else
             {        
              dataFile.close();
              dataFile = SD.open(fileplay,FILE_WRITE);
              if (dataFile) 
                {
                 z1=0;
                 Serial.print("OK para WRITE ");
                 for(din=0;din<1000;din++) dataFile.write(z1); //quita 1000 bytes del wav
                 fin=0;
                }
              else
                {
                 Serial.print("Error "); 
                }
              Serial.println(fileplay);
             }      
            inputString = "";
            stringComplete = false;
           }                     
           break;         
       }  
  
  
}

void serialEvent() 
{
 int z;
  while (Serial.available()) 
   {
    char inChar = (char)Serial.read(); 
    inputString += inChar;
    if (inChar == '\n')  
       {
         inputString.toCharArray(fileplay,19);
         for(z=inputString.length();z>=0 && z<19;z--) if(fileplay[z]<30) fileplay[z]=0;
         
         if(!strcmp(fileplay,"modo=0"))
            {
             modo=0;
             ClearBuffer();
             inputString=""; 
             Serial.println("Modo=paso");             
             goto salir1;
            }
         if(!strcmp(fileplay,"modo=1"))
            {
             modo=1;
             ClearBuffer();
             inputString="";                    
             Serial.println("Modo=reproductor");            
             goto salir1;
            }
         if(!strcmp(fileplay,"modo=2"))
            {
             modo=2;
             ClearBuffer();
             inputString="";                    
             Serial.println("Modo=grabador");             
             goto salir1;
            }
         stringComplete = true;
salir1:         
      ;
       }
   }
}


void ClearBuffer()
{
  for(din=0;din<100;din++){ bufer0[din]=128;  bufer1[din]=128;} //vacia bufer   
}

 //Read ADC
int analogReadFast()
{
 ADCSRA|=(1<<ADSC);
 // ADSC is cleared when the conversion finishes
 while (bit_is_set(ADCSRA, ADSC));
        return ADCH;
}

